
_Main_Init:

;electronique_interface_midi_007_16f628.mpas,62 :: 		begin
;electronique_interface_midi_007_16f628.mpas,63 :: 		CMCON := 7;            // disable comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_interface_midi_007_16f628.mpas,64 :: 		OPTION_REG := 0;       // enable pullup on portB
	CLRF       OPTION_REG+0
;electronique_interface_midi_007_16f628.mpas,65 :: 		INTCON.GIE := 1;       // |- enable interrupt
	BSF        INTCON+0, 7
;electronique_interface_midi_007_16f628.mpas,66 :: 		INTCON.PEIE := 1;      // |
	BSF        INTCON+0, 6
;electronique_interface_midi_007_16f628.mpas,67 :: 		TRISA      := %11101000;
	MOVLW      232
	MOVWF      TRISA+0
;electronique_interface_midi_007_16f628.mpas,68 :: 		TRISB      := %11111010;
	MOVLW      250
	MOVWF      TRISB+0
;electronique_interface_midi_007_16f628.mpas,69 :: 		PORTA      := 0;  // clear porta
	CLRF       PORTA+0
;electronique_interface_midi_007_16f628.mpas,70 :: 		PORTB      := 0;  // clear portb
	CLRF       PORTB+0
;electronique_interface_midi_007_16f628.mpas,71 :: 		T1CON.T1CKPS1 := 1;
	BSF        T1CON+0, 5
;electronique_interface_midi_007_16f628.mpas,72 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_007_16f628.mpas,74 :: 		TXSTA.SYNC := 0;    // asynchronous mode
	BCF        TXSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,75 :: 		TXSTA.TX9 := 0;     // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_interface_midi_007_16f628.mpas,76 :: 		TXSTA.TXEN := 1;    // Tx enabled
	BSF        TXSTA+0, 5
;electronique_interface_midi_007_16f628.mpas,77 :: 		RCSTA.CREN := 1;    // enable receiving / accept continuous mode
	BSF        RCSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,78 :: 		RCSTA.SPEN := 1;    // Rx enabled;
	BSF        RCSTA+0, 7
;electronique_interface_midi_007_16f628.mpas,79 :: 		RCSTA.RX9 := 0;     // 8-bits transmission
	BCF        RCSTA+0, 6
;electronique_interface_midi_007_16f628.mpas,80 :: 		PIE1.RCIE := 1;     // enable interrupt for UART Rx
	BSF        PIE1+0, 5
;electronique_interface_midi_007_16f628.mpas,82 :: 		UART1_Init(31250);  // speed for MIDI communication
	MOVLW      39
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_interface_midi_007_16f628.mpas,84 :: 		Delay_ms(100);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L__Main_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init1
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,85 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007_16f628.mpas,86 :: 		Out_Clock := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,87 :: 		Out_Strobe := 1;
	BSF        RA2_bit+0, 2
;electronique_interface_midi_007_16f628.mpas,88 :: 		end;
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_interface_midi_007_16f628.mpas,91 :: 		begin
;electronique_interface_midi_007_16f628.mpas,92 :: 		if TestBit(PIR1, RCIF) then
	CLRF       R0+0
	BTFSS      PIR1+0, 5
	GOTO       L__Interrupt6
	MOVLW      1
	MOVWF      R0+0
L__Interrupt6:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt4
;electronique_interface_midi_007_16f628.mpas,95 :: 		RxData := RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _RxData+0
;electronique_interface_midi_007_16f628.mpas,98 :: 		if (not (RxData = cMIDI_Active_Sensing)) then
	MOVF       _RxData+0, 0
	XORLW      254
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	COMF       R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt8
;electronique_interface_midi_007_16f628.mpas,99 :: 		bDataReceived := true;
	MOVLW      255
	MOVWF      _bDataReceived+0
L__Interrupt8:
;electronique_interface_midi_007_16f628.mpas,100 :: 		if TestBit(RCSTA, OERR) then
	CLRF       R0+0
	BTFSS      RCSTA+0, 1
	GOTO       L__Interrupt13
	MOVLW      1
	MOVWF      R0+0
L__Interrupt13:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt11
;electronique_interface_midi_007_16f628.mpas,102 :: 		ClearBit(RCSTA, CREN);
	BCF        RCSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,103 :: 		SetBit(RCSTA, CREN);
	BSF        RCSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,104 :: 		end;
L__Interrupt11:
;electronique_interface_midi_007_16f628.mpas,106 :: 		end;
L__Interrupt4:
;electronique_interface_midi_007_16f628.mpas,107 :: 		end;
L__Interrupt152:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Note_Play:

;electronique_interface_midi_007_16f628.mpas,110 :: 		begin
;electronique_interface_midi_007_16f628.mpas,111 :: 		UART1_Write(Data1);
	MOVF       FARG_Note_Play_Data1+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007_16f628.mpas,112 :: 		UART1_Write(Data2);
	MOVF       FARG_Note_Play_Data2+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007_16f628.mpas,113 :: 		UART1_Write(Data3);
	MOVF       FARG_Note_Play_Data3+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007_16f628.mpas,114 :: 		end;
	RETURN
; end of _Note_Play

_Rx_Reset:

;electronique_interface_midi_007_16f628.mpas,117 :: 		begin
;electronique_interface_midi_007_16f628.mpas,118 :: 		for i := 1 to 3 do
	MOVLW      1
	MOVWF      _i+0
L__Rx_Reset17:
;electronique_interface_midi_007_16f628.mpas,119 :: 		ArrRxData[i] := $00;
	DECF       _i+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	CLRF       INDF+0
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__Rx_Reset20
	INCF       _i+0, 1
	GOTO       L__Rx_Reset17
L__Rx_Reset20:
;electronique_interface_midi_007_16f628.mpas,120 :: 		end;
	RETURN
; end of _Rx_Reset

_Disp_Init:

;electronique_interface_midi_007_16f628.mpas,123 :: 		begin
;electronique_interface_midi_007_16f628.mpas,125 :: 		for i := 0 to 15 do
	CLRF       _i+0
L__Disp_Init23:
;electronique_interface_midi_007_16f628.mpas,127 :: 		for j := 0 to 7 do
	CLRF       _j+0
L__Disp_Init28:
;electronique_interface_midi_007_16f628.mpas,128 :: 		ArrOuts[i].j := 0;
	MOVF       _i+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _j+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__Disp_Init153:
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Init154
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__Disp_Init153
L__Disp_Init154:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       _j+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Init31
	INCF       _j+0, 1
	GOTO       L__Disp_Init28
L__Disp_Init31:
;electronique_interface_midi_007_16f628.mpas,129 :: 		end;
	MOVF       _i+0, 0
	XORLW      15
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Init26
	INCF       _i+0, 1
	GOTO       L__Disp_Init23
L__Disp_Init26:
;electronique_interface_midi_007_16f628.mpas,130 :: 		end;
	RETURN
; end of _Disp_Init

_Out_Refresh:

;electronique_interface_midi_007_16f628.mpas,136 :: 		begin
;electronique_interface_midi_007_16f628.mpas,143 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007_16f628.mpas,145 :: 		Out_Clock := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,147 :: 		Out_Strobe := 0;
	BCF        RA2_bit+0, 2
;electronique_interface_midi_007_16f628.mpas,149 :: 		for iOutGroup2 := 15 downto 0 do
	MOVLW      15
	MOVWF      _iOutGroup2+0
L__Out_Refresh36:
;electronique_interface_midi_007_16f628.mpas,151 :: 		for iOutBit2 := 7 downto 0 do
	MOVLW      7
	MOVWF      _iOutBit2+0
L__Out_Refresh41:
;electronique_interface_midi_007_16f628.mpas,153 :: 		Out_Data := ArrOuts[iOutGroup2].iOutBit2;
	MOVF       _iOutGroup2+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      FSR
	MOVF       _iOutBit2+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__Out_Refresh155:
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh156
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__Out_Refresh155
L__Out_Refresh156:
	MOVF       R0+0, 0
	ANDWF      INDF+0, 0
	MOVWF      R2+0
	CLRF       R1+0
	MOVF       R2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh45
	MOVLW      1
	MOVWF      R1+0
L__Out_Refresh45:
	BTFSC      R1+0, 0
	GOTO       L__Out_Refresh157
	BCF        RA0_bit+0, 0
	GOTO       L__Out_Refresh158
L__Out_Refresh157:
	BSF        RA0_bit+0, 0
L__Out_Refresh158:
;electronique_interface_midi_007_16f628.mpas,154 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,155 :: 		Out_Clock := 1;   // clock high
	BSF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,156 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,157 :: 		Out_Clock := 0; // clock low
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,158 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,159 :: 		end;
	MOVF       _iOutBit2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh44
	DECF       _iOutBit2+0, 1
	GOTO       L__Out_Refresh41
L__Out_Refresh44:
;electronique_interface_midi_007_16f628.mpas,160 :: 		end;
	MOVF       _iOutGroup2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh39
	DECF       _iOutGroup2+0, 1
	GOTO       L__Out_Refresh36
L__Out_Refresh39:
;electronique_interface_midi_007_16f628.mpas,162 :: 		Out_Strobe := 1;
	BSF        RA2_bit+0, 2
;electronique_interface_midi_007_16f628.mpas,164 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007_16f628.mpas,165 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,166 :: 		end;
	RETURN
; end of _Out_Refresh

_Main_Welcome:

;electronique_interface_midi_007_16f628.mpas,169 :: 		begin
;electronique_interface_midi_007_16f628.mpas,170 :: 		Note_Play(cMIDI_Note_On_Ch_1, cMIDI_Pitch_base, cMIDI_Vel_On);
	MOVLW      144
	MOVWF      FARG_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_Note_Play_Data2+0
	MOVLW      100
	MOVWF      FARG_Note_Play_Data3+0
	CALL       _Note_Play+0
;electronique_interface_midi_007_16f628.mpas,171 :: 		Delay_ms(100);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L__Main_Welcome47:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome47
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome47
	DECFSZ     R11+0, 1
	GOTO       L__Main_Welcome47
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,172 :: 		Note_Play(cMIDI_Note_Off_Ch_1, cMIDI_Pitch_base, cMIDI_Vel_Off);
	MOVLW      128
	MOVWF      FARG_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_Note_Play_Data2+0
	CLRF       FARG_Note_Play_Data3+0
	CALL       _Note_Play+0
;electronique_interface_midi_007_16f628.mpas,173 :: 		Delay_ms(30);
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L__Main_Welcome48:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome48
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome48
;electronique_interface_midi_007_16f628.mpas,174 :: 		end;
	RETURN
; end of _Main_Welcome

_Midi_GetChannelSetting:

;electronique_interface_midi_007_16f628.mpas,177 :: 		begin
;electronique_interface_midi_007_16f628.mpas,178 :: 		iMidiChannelSet := 0;
	CLRF       _iMidiChannelSet+0
;electronique_interface_midi_007_16f628.mpas,179 :: 		if In_MidiCh_bit0 then iMidiChannelSet := iMidiChannelSet + 1;
	BTFSS      RB3_bit+0, 3
	GOTO       L__Midi_GetChannelSetting51
	INCF       _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting51:
;electronique_interface_midi_007_16f628.mpas,180 :: 		if In_MidiCh_bit1 then iMidiChannelSet := iMidiChannelSet + 2;
	BTFSS      RB4_bit+0, 4
	GOTO       L__Midi_GetChannelSetting54
	MOVLW      2
	ADDWF      _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting54:
;electronique_interface_midi_007_16f628.mpas,181 :: 		if In_MidiCh_bit2 then iMidiChannelSet := iMidiChannelSet + 4;
	BTFSS      RB5_bit+0, 5
	GOTO       L__Midi_GetChannelSetting57
	MOVLW      4
	ADDWF      _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting57:
;electronique_interface_midi_007_16f628.mpas,182 :: 		if In_MidiCh_bit3 then iMidiChannelSet := iMidiChannelSet + 8;
	BTFSS      RB6_bit+0, 6
	GOTO       L__Midi_GetChannelSetting60
	MOVLW      8
	ADDWF      _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting60:
;electronique_interface_midi_007_16f628.mpas,183 :: 		end;
	RETURN
; end of _Midi_GetChannelSetting

_main:

;electronique_interface_midi_007_16f628.mpas,186 :: 		begin
;electronique_interface_midi_007_16f628.mpas,187 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_interface_midi_007_16f628.mpas,188 :: 		bRxEcho := In_RxEcho;
	MOVLW      0
	BTFSC      RA3_bit+0, 3
	MOVLW      1
	MOVWF      _bRxEcho+0
;electronique_interface_midi_007_16f628.mpas,189 :: 		bModePulse := In_Mode;      // RB7=1 > selected out play as pulse
	MOVLW      0
	BTFSC      RB7_bit+0, 7
	MOVLW      1
	MOVWF      _bModePulse+0
;electronique_interface_midi_007_16f628.mpas,192 :: 		Disp_Init;
	CALL       _Disp_Init+0
;electronique_interface_midi_007_16f628.mpas,195 :: 		Main_Welcome;
	CALL       _Main_Welcome+0
;electronique_interface_midi_007_16f628.mpas,198 :: 		Midi_GetChannelSetting;
	CALL       _Midi_GetChannelSetting+0
;electronique_interface_midi_007_16f628.mpas,201 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_007_16f628.mpas,202 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_007_16f628.mpas,204 :: 		while true do
L__main64:
;electronique_interface_midi_007_16f628.mpas,207 :: 		if bDataReceived then
	MOVF       _bDataReceived+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main69
;electronique_interface_midi_007_16f628.mpas,209 :: 		bDataReceived := false;
	CLRF       _bDataReceived+0
;electronique_interface_midi_007_16f628.mpas,212 :: 		if bRxEcho then
	MOVF       _bRxEcho+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main72
;electronique_interface_midi_007_16f628.mpas,213 :: 		UART1_Write(RxData);
	MOVF       _RxData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
L__main72:
;electronique_interface_midi_007_16f628.mpas,216 :: 		if (((rxData and $F0) = cMIDI_Note_On_Ch_1) or
	MOVLW      240
	ANDWF      _RxData+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_007_16f628.mpas,217 :: 		((rxData and $F0) = cMIDI_Note_Off_Ch_1)) then
	MOVF       R2+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main75
;electronique_interface_midi_007_16f628.mpas,219 :: 		iRxByteCount := 1;
	MOVLW      1
	MOVWF      _iRxByteCount+0
;electronique_interface_midi_007_16f628.mpas,220 :: 		ArrRxData[iRxByteCount] := RxData;
	CLRF       R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       _RxData+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,221 :: 		end
	GOTO       L__main76
;electronique_interface_midi_007_16f628.mpas,222 :: 		else
L__main75:
;electronique_interface_midi_007_16f628.mpas,224 :: 		inc(iRxByteCount);
	INCF       _iRxByteCount+0, 1
;electronique_interface_midi_007_16f628.mpas,225 :: 		ArrRxData[iRxByteCount] := RxData;
	DECF       _iRxByteCount+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       _RxData+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,228 :: 		if iRxByteCount >= 3 then
	MOVLW      3
	SUBWF      _iRxByteCount+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L__main78
;electronique_interface_midi_007_16f628.mpas,233 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) and
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_007_16f628.mpas,234 :: 		(ArrRxData[3] > $00));
	MOVF       _ArrRxData+2, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R3+0
	MOVF       R3+0, 0
	MOVWF      _bNoteOn+0
;electronique_interface_midi_007_16f628.mpas,237 :: 		(((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) and
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_007_16f628.mpas,238 :: 		(ArrRxData[3] = $00)) or
	MOVF       _ArrRxData+2, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R2+0
;electronique_interface_midi_007_16f628.mpas,239 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_Off_Ch_1));
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _bNoteOff+0
;electronique_interface_midi_007_16f628.mpas,242 :: 		iMidiChannelRx := ArrRxData[1] and $0F;
	MOVLW      15
	ANDWF      _ArrRxData+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      _iMidiChannelRx+0
;electronique_interface_midi_007_16f628.mpas,245 :: 		if ((bNoteOn or bNoteOff) and (iMidiChannelRx = iMidiChannelSet)) then
	MOVF       R0+0, 0
	IORWF      R3+0, 0
	MOVWF      R1+0
	MOVF       R2+0, 0
	XORWF      _iMidiChannelSet+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main81
;electronique_interface_midi_007_16f628.mpas,250 :: 		if ((ArrRxData[2] >= 0) and (ArrRxData[2] <= 7)) then
	MOVLW      0
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      7
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main84
;electronique_interface_midi_007_16f628.mpas,252 :: 		iOutGroup := 0;
	CLRF       _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,253 :: 		iOutBit := ArrRxData[2];
	MOVF       _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,254 :: 		end
	GOTO       L__main85
;electronique_interface_midi_007_16f628.mpas,255 :: 		else if ((ArrRxData[2] >= 8) and (ArrRxData[2] <= 15)) then
L__main84:
	MOVLW      8
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      15
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main87
;electronique_interface_midi_007_16f628.mpas,257 :: 		iOutGroup := 1;
	MOVLW      1
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,258 :: 		iOutBit := ArrRxData[2] - 8;
	MOVLW      8
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,259 :: 		end
	GOTO       L__main88
;electronique_interface_midi_007_16f628.mpas,260 :: 		else if ((ArrRxData[2] >= 16) and (ArrRxData[2] <= 23)) then
L__main87:
	MOVLW      16
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      23
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main90
;electronique_interface_midi_007_16f628.mpas,262 :: 		iOutGroup := 2;
	MOVLW      2
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,263 :: 		iOutBit := ArrRxData[2] - 16;
	MOVLW      16
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,264 :: 		end
	GOTO       L__main91
;electronique_interface_midi_007_16f628.mpas,265 :: 		else if ((ArrRxData[2] >= 24) and (ArrRxData[2] <= 31)) then
L__main90:
	MOVLW      24
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      31
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main93
;electronique_interface_midi_007_16f628.mpas,267 :: 		iOutGroup := 3;
	MOVLW      3
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,268 :: 		iOutBit := ArrRxData[2] - 24;
	MOVLW      24
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,269 :: 		end
	GOTO       L__main94
;electronique_interface_midi_007_16f628.mpas,270 :: 		else if ((ArrRxData[2] >= 32) and (ArrRxData[2] <= 39)) then
L__main93:
	MOVLW      32
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      39
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main96
;electronique_interface_midi_007_16f628.mpas,272 :: 		iOutGroup := 4;
	MOVLW      4
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,273 :: 		iOutBit := ArrRxData[2] - 32;
	MOVLW      32
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,274 :: 		end
	GOTO       L__main97
;electronique_interface_midi_007_16f628.mpas,275 :: 		else if ((ArrRxData[2] >= 40) and (ArrRxData[2] <= 47)) then
L__main96:
	MOVLW      40
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      47
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main99
;electronique_interface_midi_007_16f628.mpas,277 :: 		iOutGroup := 5;
	MOVLW      5
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,278 :: 		iOutBit := ArrRxData[2] - 40;
	MOVLW      40
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,279 :: 		end
	GOTO       L__main100
;electronique_interface_midi_007_16f628.mpas,280 :: 		else if ((ArrRxData[2] >= 48) and (ArrRxData[2] <= 55)) then
L__main99:
	MOVLW      48
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      55
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main102
;electronique_interface_midi_007_16f628.mpas,282 :: 		iOutGroup := 6;
	MOVLW      6
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,283 :: 		iOutBit := ArrRxData[2] - 48;
	MOVLW      48
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,284 :: 		end
	GOTO       L__main103
;electronique_interface_midi_007_16f628.mpas,285 :: 		else if ((ArrRxData[2] >= 56) and (ArrRxData[2] <= 63)) then
L__main102:
	MOVLW      56
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      63
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main105
;electronique_interface_midi_007_16f628.mpas,287 :: 		iOutGroup := 7;
	MOVLW      7
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,288 :: 		iOutBit := ArrRxData[2] - 56;
	MOVLW      56
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,289 :: 		end
	GOTO       L__main106
;electronique_interface_midi_007_16f628.mpas,290 :: 		else if ((ArrRxData[2] >= 64) and (ArrRxData[2] <= 71)) then
L__main105:
	MOVLW      64
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      71
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main108
;electronique_interface_midi_007_16f628.mpas,292 :: 		iOutGroup := 8;
	MOVLW      8
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,293 :: 		iOutBit := ArrRxData[2] - 64;
	MOVLW      64
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,294 :: 		end
	GOTO       L__main109
;electronique_interface_midi_007_16f628.mpas,295 :: 		else if ((ArrRxData[2] >= 72) and (ArrRxData[2] <= 79)) then
L__main108:
	MOVLW      72
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      79
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main111
;electronique_interface_midi_007_16f628.mpas,297 :: 		iOutGroup := 9;
	MOVLW      9
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,298 :: 		iOutBit := ArrRxData[2] - 72;
	MOVLW      72
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,299 :: 		end
	GOTO       L__main112
;electronique_interface_midi_007_16f628.mpas,300 :: 		else if ((ArrRxData[2] >= 80) and (ArrRxData[2] <= 87)) then
L__main111:
	MOVLW      80
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      87
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main114
;electronique_interface_midi_007_16f628.mpas,302 :: 		iOutGroup := 10;
	MOVLW      10
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,303 :: 		iOutBit := ArrRxData[2] - 80;
	MOVLW      80
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,304 :: 		end
	GOTO       L__main115
;electronique_interface_midi_007_16f628.mpas,305 :: 		else if ((ArrRxData[2] >= 88) and (ArrRxData[2] <= 95)) then
L__main114:
	MOVLW      88
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      95
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main117
;electronique_interface_midi_007_16f628.mpas,307 :: 		iOutGroup := 11;
	MOVLW      11
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,308 :: 		iOutBit := ArrRxData[2] - 88;
	MOVLW      88
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,309 :: 		end
	GOTO       L__main118
;electronique_interface_midi_007_16f628.mpas,310 :: 		else if ((ArrRxData[2] >= 96) and (ArrRxData[2] <= 103)) then
L__main117:
	MOVLW      96
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      103
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main120
;electronique_interface_midi_007_16f628.mpas,312 :: 		iOutGroup := 12;
	MOVLW      12
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,313 :: 		iOutBit := ArrRxData[2] - 96;
	MOVLW      96
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,314 :: 		end
	GOTO       L__main121
;electronique_interface_midi_007_16f628.mpas,315 :: 		else if ((ArrRxData[2] >= 104) and (ArrRxData[2] <= 111)) then
L__main120:
	MOVLW      104
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      111
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main123
;electronique_interface_midi_007_16f628.mpas,317 :: 		iOutGroup := 13;
	MOVLW      13
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,318 :: 		iOutBit := ArrRxData[2] - 104;
	MOVLW      104
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,319 :: 		end
	GOTO       L__main124
;electronique_interface_midi_007_16f628.mpas,320 :: 		else if ((ArrRxData[2] >= 112) and (ArrRxData[2] <= 119)) then
L__main123:
	MOVLW      112
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      119
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main126
;electronique_interface_midi_007_16f628.mpas,322 :: 		iOutGroup := 14;
	MOVLW      14
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,323 :: 		iOutBit := ArrRxData[2] - 112;
	MOVLW      112
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,324 :: 		end
	GOTO       L__main127
;electronique_interface_midi_007_16f628.mpas,325 :: 		else if ((ArrRxData[2] >= 120) and (ArrRxData[2] <= 127)) then
L__main126:
	MOVLW      120
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      127
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main129
;electronique_interface_midi_007_16f628.mpas,327 :: 		iOutGroup := 15;
	MOVLW      15
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,328 :: 		iOutBit := ArrRxData[2] - 120;
	MOVLW      120
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,329 :: 		end;
L__main129:
L__main127:
L__main124:
L__main121:
L__main118:
L__main115:
L__main112:
L__main109:
L__main106:
L__main103:
L__main100:
L__main97:
L__main94:
L__main91:
L__main88:
L__main85:
;electronique_interface_midi_007_16f628.mpas,332 :: 		if bModePulse then
	MOVF       _bModePulse+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main132
;electronique_interface_midi_007_16f628.mpas,336 :: 		if bNoteOn then
	MOVF       _bNoteOn+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main135
;electronique_interface_midi_007_16f628.mpas,339 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_007_16f628.mpas,341 :: 		ArrOuts[iOutGroup].iOutBit := 1;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main159:
	BTFSC      STATUS+0, 2
	GOTO       L__main160
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main159
L__main160:
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,343 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007_16f628.mpas,345 :: 		Delay_ms(1); // or Delay_ms(10) for example
	MOVLW      7
	MOVWF      R12+0
	MOVLW      125
	MOVWF      R13+0
L__main139:
	DECFSZ     R13+0, 1
	GOTO       L__main139
	DECFSZ     R12+0, 1
	GOTO       L__main139
;electronique_interface_midi_007_16f628.mpas,347 :: 		ArrOuts[iOutGroup].iOutBit := 0;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main161:
	BTFSC      STATUS+0, 2
	GOTO       L__main162
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main161
L__main162:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,349 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007_16f628.mpas,350 :: 		end;
L__main135:
;electronique_interface_midi_007_16f628.mpas,362 :: 		end
	GOTO       L__main133
;electronique_interface_midi_007_16f628.mpas,363 :: 		else
L__main132:
;electronique_interface_midi_007_16f628.mpas,368 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_007_16f628.mpas,370 :: 		if bNoteOn then
	MOVF       _bNoteOn+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main143
;electronique_interface_midi_007_16f628.mpas,371 :: 		ArrOuts[iOutGroup].iOutBit := 1
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main163:
	BTFSC      STATUS+0, 2
	GOTO       L__main164
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main163
L__main164:
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	GOTO       L__main144
;electronique_interface_midi_007_16f628.mpas,372 :: 		else if bNoteOff then
L__main143:
	MOVF       _bNoteOff+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main148
;electronique_interface_midi_007_16f628.mpas,373 :: 		ArrOuts[iOutGroup].iOutBit := 0;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main165:
	BTFSC      STATUS+0, 2
	GOTO       L__main166
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main165
L__main166:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
L__main148:
L__main144:
;electronique_interface_midi_007_16f628.mpas,375 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007_16f628.mpas,376 :: 		end;
L__main133:
;electronique_interface_midi_007_16f628.mpas,378 :: 		end;
L__main81:
;electronique_interface_midi_007_16f628.mpas,380 :: 		end;
L__main78:
;electronique_interface_midi_007_16f628.mpas,381 :: 		end;
L__main76:
;electronique_interface_midi_007_16f628.mpas,382 :: 		end;
L__main69:
;electronique_interface_midi_007_16f628.mpas,385 :: 		end;
	GOTO       L__main64
;electronique_interface_midi_007_16f628.mpas,387 :: 		end.
	GOTO       $+0
; end of _main
