
_Main_Init:

;electronique_interface_midi_007b_16f628.mpas,83 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,84 :: 		CMCON := 7;            // disable comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_interface_midi_007b_16f628.mpas,85 :: 		OPTION_REG := 0;       // enable pullup on portB
	CLRF       OPTION_REG+0
;electronique_interface_midi_007b_16f628.mpas,86 :: 		INTCON.GIE := 1;       // |- enable interrupt
	BSF        INTCON+0, 7
;electronique_interface_midi_007b_16f628.mpas,87 :: 		INTCON.PEIE := 1;      // |
	BSF        INTCON+0, 6
;electronique_interface_midi_007b_16f628.mpas,88 :: 		TRISA      := %11101000;
	MOVLW      232
	MOVWF      TRISA+0
;electronique_interface_midi_007b_16f628.mpas,89 :: 		TRISB      := %11111010;
	MOVLW      250
	MOVWF      TRISB+0
;electronique_interface_midi_007b_16f628.mpas,90 :: 		PORTA      := 0;  // clear porta
	CLRF       PORTA+0
;electronique_interface_midi_007b_16f628.mpas,91 :: 		PORTB      := 0;  // clear portb
	CLRF       PORTB+0
;electronique_interface_midi_007b_16f628.mpas,92 :: 		T1CON.T1CKPS1 := 1;
	BSF        T1CON+0, 5
;electronique_interface_midi_007b_16f628.mpas,93 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_007b_16f628.mpas,95 :: 		TXSTA.SYNC := 0;     // asynchronous mode
	BCF        TXSTA+0, 4
;electronique_interface_midi_007b_16f628.mpas,96 :: 		TXSTA.TX9 := 0;      // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_interface_midi_007b_16f628.mpas,97 :: 		TXSTA.TXEN := 1;     // Tx enabled
	BSF        TXSTA+0, 5
;electronique_interface_midi_007b_16f628.mpas,98 :: 		RCSTA.CREN := 1;     // enable receiving / accept continuous mode
	BSF        RCSTA+0, 4
;electronique_interface_midi_007b_16f628.mpas,99 :: 		RCSTA.SPEN := 1;     // Rx enabled;
	BSF        RCSTA+0, 7
;electronique_interface_midi_007b_16f628.mpas,100 :: 		RCSTA.RX9 := 0;      // 8-bits transmission
	BCF        RCSTA+0, 6
;electronique_interface_midi_007b_16f628.mpas,101 :: 		PIE1.RCIE := 1;      // enable interrupt for UART Rx
	BSF        PIE1+0, 5
;electronique_interface_midi_007b_16f628.mpas,103 :: 		UART1_Init(cMidiBaudrate); // speed for MIDI communication
	MOVLW      39
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_interface_midi_007b_16f628.mpas,105 :: 		Delay_ms(100);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L__Main_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init1
	NOP
	NOP
;electronique_interface_midi_007b_16f628.mpas,106 :: 		SetBit(RCSTA,CREN);  // enable receiver
	BSF        RCSTA+0, 4
;electronique_interface_midi_007b_16f628.mpas,107 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007b_16f628.mpas,108 :: 		Out_Clock := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007b_16f628.mpas,109 :: 		Out_Strobe := 1;
	BSF        RA2_bit+0, 2
;electronique_interface_midi_007b_16f628.mpas,112 :: 		Memset(@ArrRxBuf, 0, cRxBufSize);
	MOVLW      _ArrRxBuf+0
	MOVWF      FARG_memset_p+0
	CLRF       FARG_memset_character+0
	MOVLW      64
	MOVWF      FARG_memset_n+0
	CLRF       FARG_memset_n+1
	CALL       _memset+0
;electronique_interface_midi_007b_16f628.mpas,113 :: 		iRxHead     := 0;
	CLRF       _iRxHead+0
;electronique_interface_midi_007b_16f628.mpas,114 :: 		iRxTail     := 0;
	CLRF       _iRxTail+0
;electronique_interface_midi_007b_16f628.mpas,115 :: 		bRxBufFull  := false ;
	CLRF       _bRxBufFull+0
;electronique_interface_midi_007b_16f628.mpas,116 :: 		bRxBufEmpty := true;
	MOVLW      255
	MOVWF      _bRxBufEmpty+0
;electronique_interface_midi_007b_16f628.mpas,117 :: 		iCounter    := 0;
	CLRF       _iCounter+0
;electronique_interface_midi_007b_16f628.mpas,118 :: 		iTermFlag   := 0;
	CLRF       _iTermFlag+0
;electronique_interface_midi_007b_16f628.mpas,120 :: 		iMatch      := 2;
	MOVLW      2
	MOVWF      _iMatch+0
;electronique_interface_midi_007b_16f628.mpas,122 :: 		end;
L_end_Main_Init:
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_interface_midi_007b_16f628.mpas,125 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,127 :: 		if PIR1.RCIF = 1 then
	BTFSS      PIR1+0, 5
	GOTO       L__Interrupt4
;electronique_interface_midi_007b_16f628.mpas,129 :: 		iRxStatus := RCSTA; // Error-handling
	MOVF       RCSTA+0, 0
	MOVWF      _iRxStatus+0
;electronique_interface_midi_007b_16f628.mpas,132 :: 		iRxData := RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _iRxData+0
;electronique_interface_midi_007b_16f628.mpas,136 :: 		if (iRxStatus and %00000110) = 0 then
	MOVLW      6
	ANDWF      _iRxStatus+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt7
;electronique_interface_midi_007b_16f628.mpas,138 :: 		if (not bRxBufFull) then       // if buffer full, do nothing
	COMF       _bRxBufFull+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt10
;electronique_interface_midi_007b_16f628.mpas,141 :: 		if (iRxData <> cMIDI_Active_Sensing) then
	MOVF       _iRxData+0, 0
	XORLW      254
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt13
;electronique_interface_midi_007b_16f628.mpas,143 :: 		ArrRxBuf[iRxTail] := iRxData;
	MOVF       _iRxTail+0, 0
	ADDLW      _ArrRxBuf+0
	MOVWF      FSR
	MOVF       _iRxData+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007b_16f628.mpas,144 :: 		Inc(iRxTail);
	INCF       _iRxTail+0, 1
;electronique_interface_midi_007b_16f628.mpas,145 :: 		if iRxTail > cRxBufSize then // reach buffer end, return to buffer start
	MOVF       _iRxTail+0, 0
	SUBLW      64
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt16
;electronique_interface_midi_007b_16f628.mpas,146 :: 		iRxTail := 0;
	CLRF       _iRxTail+0
L__Interrupt16:
;electronique_interface_midi_007b_16f628.mpas,147 :: 		bRxBufEmpty := false;        // flag that some data have been received
	CLRF       _bRxBufEmpty+0
;electronique_interface_midi_007b_16f628.mpas,148 :: 		if iRxTail = iRxHead then
	MOVF       _iRxTail+0, 0
	XORWF      _iRxHead+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt19
;electronique_interface_midi_007b_16f628.mpas,149 :: 		bRxBufFull := true;
	MOVLW      255
	MOVWF      _bRxBufFull+0
L__Interrupt19:
;electronique_interface_midi_007b_16f628.mpas,161 :: 		end;
L__Interrupt13:
;electronique_interface_midi_007b_16f628.mpas,162 :: 		end;
L__Interrupt10:
;electronique_interface_midi_007b_16f628.mpas,163 :: 		end
	GOTO       L__Interrupt8
;electronique_interface_midi_007b_16f628.mpas,164 :: 		else
L__Interrupt7:
;electronique_interface_midi_007b_16f628.mpas,168 :: 		Clearbit(RCSTA, CREN);
	BCF        RCSTA+0, 4
;electronique_interface_midi_007b_16f628.mpas,169 :: 		Setbit(RCSTA, CREN);
	BSF        RCSTA+0, 4
;electronique_interface_midi_007b_16f628.mpas,170 :: 		end;
L__Interrupt8:
;electronique_interface_midi_007b_16f628.mpas,171 :: 		end;
L__Interrupt4:
;electronique_interface_midi_007b_16f628.mpas,192 :: 		end;
L_end_Interrupt:
L__Interrupt163:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Midi_DataReceived:

;electronique_interface_midi_007b_16f628.mpas,195 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,197 :: 		result := (not bRxBufEmpty);
	COMF       _bRxBufEmpty+0, 0
	MOVWF      R1+0
;electronique_interface_midi_007b_16f628.mpas,199 :: 		end;
	MOVF       R1+0, 0
	MOVWF      R0+0
L_end_Midi_DataReceived:
	RETURN
; end of _Midi_DataReceived

_Midi_MsgReceived:

;electronique_interface_midi_007b_16f628.mpas,205 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,211 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) or
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
;electronique_interface_midi_007b_16f628.mpas,212 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_Off_Ch_1));
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	IORWF      R2+0, 0
	MOVWF      R1+0
;electronique_interface_midi_007b_16f628.mpas,214 :: 		bFullMsgReceived := (iRxByteCount = 3);
	MOVF       _iRxByteCount+0, 0
	XORLW      3
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
;electronique_interface_midi_007b_16f628.mpas,216 :: 		result := (bNoteDetected and bFullMsgReceived);
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R3+0
;electronique_interface_midi_007b_16f628.mpas,218 :: 		end;
	MOVF       R3+0, 0
	MOVWF      R0+0
L_end_Midi_MsgReceived:
	RETURN
; end of _Midi_MsgReceived

_Midi_RxReadByte:

;electronique_interface_midi_007b_16f628.mpas,224 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,226 :: 		Rk := 0;
	CLRF       Midi_RxReadByte_Rk+0
;electronique_interface_midi_007b_16f628.mpas,228 :: 		if bRxBufEmpty = false then
	MOVF       _bRxBufEmpty+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Midi_RxReadByte25
;electronique_interface_midi_007b_16f628.mpas,231 :: 		Rk := ArrRxBuf[iRxHead];
	MOVF       _iRxHead+0, 0
	ADDLW      _ArrRxBuf+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      Midi_RxReadByte_Rk+0
;electronique_interface_midi_007b_16f628.mpas,234 :: 		if bRxEcho then
	MOVF       _bRxEcho+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Midi_RxReadByte28
;electronique_interface_midi_007b_16f628.mpas,235 :: 		UART1_Write(Rk);
	MOVF       Midi_RxReadByte_Rk+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
L__Midi_RxReadByte28:
;electronique_interface_midi_007b_16f628.mpas,239 :: 		((Rk and $F0) = cMIDI_Note_On_Ch_1) or
	MOVLW      240
	ANDWF      Midi_RxReadByte_Rk+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_007b_16f628.mpas,240 :: 		((Rk and $F0) = cMIDI_Note_Off_Ch_1));
	MOVF       R2+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
;electronique_interface_midi_007b_16f628.mpas,241 :: 		if bNoteDetected then
	BTFSC      STATUS+0, 2
	GOTO       L__Midi_RxReadByte31
;electronique_interface_midi_007b_16f628.mpas,243 :: 		iRxByteCount := 1;
	MOVLW      1
	MOVWF      _iRxByteCount+0
;electronique_interface_midi_007b_16f628.mpas,244 :: 		ArrRxData[iRxByteCount] := Rk;
	CLRF       R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       Midi_RxReadByte_Rk+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007b_16f628.mpas,245 :: 		end
	GOTO       L__Midi_RxReadByte32
;electronique_interface_midi_007b_16f628.mpas,246 :: 		else
L__Midi_RxReadByte31:
;electronique_interface_midi_007b_16f628.mpas,248 :: 		inc(iRxByteCount);
	INCF       _iRxByteCount+0, 1
;electronique_interface_midi_007b_16f628.mpas,249 :: 		ArrRxData[iRxByteCount] := Rk;
	DECF       _iRxByteCount+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       Midi_RxReadByte_Rk+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007b_16f628.mpas,250 :: 		end;
L__Midi_RxReadByte32:
;electronique_interface_midi_007b_16f628.mpas,252 :: 		ArrRxBuf[iRxHead] := 0; // clear value that has been read (not really needed ?)
	MOVF       _iRxHead+0, 0
	ADDLW      _ArrRxBuf+0
	MOVWF      FSR
	CLRF       INDF+0
;electronique_interface_midi_007b_16f628.mpas,253 :: 		inc(iRxHead);
	INCF       _iRxHead+0, 1
;electronique_interface_midi_007b_16f628.mpas,254 :: 		if iRxHead > cRxBufSize then
	MOVF       _iRxHead+0, 0
	SUBLW      64
	BTFSC      STATUS+0, 0
	GOTO       L__Midi_RxReadByte34
;electronique_interface_midi_007b_16f628.mpas,255 :: 		iRxHead := 0;
	CLRF       _iRxHead+0
L__Midi_RxReadByte34:
;electronique_interface_midi_007b_16f628.mpas,256 :: 		bRxBufEmpty := (iRxHead = iRxTail); // all received bytes have been read
	MOVF       _iRxHead+0, 0
	XORWF      _iRxTail+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      _bRxBufEmpty+0
;electronique_interface_midi_007b_16f628.mpas,258 :: 		end;
L__Midi_RxReadByte25:
;electronique_interface_midi_007b_16f628.mpas,259 :: 		Result := Rk;
	MOVF       Midi_RxReadByte_Rk+0, 0
	MOVWF      Midi_RxReadByte_local_result+0
;electronique_interface_midi_007b_16f628.mpas,260 :: 		end;
	MOVF       Midi_RxReadByte_local_result+0, 0
	MOVWF      R0+0
L_end_Midi_RxReadByte:
	RETURN
; end of _Midi_RxReadByte

_Midi_TxNotePlay:

;electronique_interface_midi_007b_16f628.mpas,263 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,264 :: 		UART1_Write(Data1);
	MOVF       FARG_Midi_TxNotePlay_Data1+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007b_16f628.mpas,265 :: 		UART1_Write(Data2);
	MOVF       FARG_Midi_TxNotePlay_Data2+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007b_16f628.mpas,266 :: 		UART1_Write(Data3);
	MOVF       FARG_Midi_TxNotePlay_Data3+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007b_16f628.mpas,267 :: 		end;
L_end_Midi_TxNotePlay:
	RETURN
; end of _Midi_TxNotePlay

_Rx_Reset:

;electronique_interface_midi_007b_16f628.mpas,270 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,271 :: 		for i := 1 to 3 do
	MOVLW      1
	MOVWF      _i+0
L__Rx_Reset39:
;electronique_interface_midi_007b_16f628.mpas,272 :: 		ArrRxData[i] := $00;
	DECF       _i+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	CLRF       INDF+0
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__Rx_Reset42
	INCF       _i+0, 1
	GOTO       L__Rx_Reset39
L__Rx_Reset42:
;electronique_interface_midi_007b_16f628.mpas,273 :: 		end;
L_end_Rx_Reset:
	RETURN
; end of _Rx_Reset

_Disp_Init:

;electronique_interface_midi_007b_16f628.mpas,276 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,278 :: 		for i := 0 to 15 do
	CLRF       _i+0
L__Disp_Init45:
;electronique_interface_midi_007b_16f628.mpas,279 :: 		ArrOuts[i] := $00;
	MOVF       _i+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      FSR
	CLRF       INDF+0
	MOVF       _i+0, 0
	XORLW      15
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Init48
	INCF       _i+0, 1
	GOTO       L__Disp_Init45
L__Disp_Init48:
;electronique_interface_midi_007b_16f628.mpas,286 :: 		end;
L_end_Disp_Init:
	RETURN
; end of _Disp_Init

_Out_Refresh:

;electronique_interface_midi_007b_16f628.mpas,292 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,299 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007b_16f628.mpas,301 :: 		Out_Clock := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007b_16f628.mpas,303 :: 		Out_Strobe := 0;
	BCF        RA2_bit+0, 2
;electronique_interface_midi_007b_16f628.mpas,305 :: 		for iOutGroup2 := 15 downto 0 do
	MOVLW      15
	MOVWF      _iOutGroup2+0
L__Out_Refresh51:
;electronique_interface_midi_007b_16f628.mpas,307 :: 		for iOutBit2 := 7 downto 0 do
	MOVLW      7
	MOVWF      _iOutBit2+0
L__Out_Refresh56:
;electronique_interface_midi_007b_16f628.mpas,309 :: 		Out_Data := ArrOuts[iOutGroup2].iOutBit2;
	MOVF       _iOutGroup2+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      FSR
	MOVF       _iOutBit2+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__Out_Refresh171:
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh172
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__Out_Refresh171
L__Out_Refresh172:
	MOVF       R0+0, 0
	ANDWF      INDF+0, 0
	MOVWF      R2+0
	CLRF       R1+0
	MOVF       R2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh60
	MOVLW      1
	MOVWF      R1+0
L__Out_Refresh60:
	BTFSC      R1+0, 0
	GOTO       L__Out_Refresh173
	BCF        RA0_bit+0, 0
	GOTO       L__Out_Refresh174
L__Out_Refresh173:
	BSF        RA0_bit+0, 0
L__Out_Refresh174:
;electronique_interface_midi_007b_16f628.mpas,310 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007b_16f628.mpas,311 :: 		Out_Clock := 1;   // clock high
	BSF        RA1_bit+0, 1
;electronique_interface_midi_007b_16f628.mpas,312 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007b_16f628.mpas,313 :: 		Out_Clock := 0; // clock low
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007b_16f628.mpas,314 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007b_16f628.mpas,315 :: 		end;
	MOVF       _iOutBit2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh59
	DECF       _iOutBit2+0, 1
	GOTO       L__Out_Refresh56
L__Out_Refresh59:
;electronique_interface_midi_007b_16f628.mpas,316 :: 		end;
	MOVF       _iOutGroup2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh54
	DECF       _iOutGroup2+0, 1
	GOTO       L__Out_Refresh51
L__Out_Refresh54:
;electronique_interface_midi_007b_16f628.mpas,318 :: 		Out_Strobe := 1;
	BSF        RA2_bit+0, 2
;electronique_interface_midi_007b_16f628.mpas,320 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007b_16f628.mpas,321 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007b_16f628.mpas,322 :: 		end;
L_end_Out_Refresh:
	RETURN
; end of _Out_Refresh

_Main_Welcome:

;electronique_interface_midi_007b_16f628.mpas,325 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,326 :: 		Midi_TxNotePlay(cMIDI_Note_On_Ch_1, cMIDI_Pitch_base, cMIDI_Vel_On);
	MOVLW      144
	MOVWF      FARG_Midi_TxNotePlay_Data1+0
	MOVLW      60
	MOVWF      FARG_Midi_TxNotePlay_Data2+0
	MOVLW      100
	MOVWF      FARG_Midi_TxNotePlay_Data3+0
	CALL       _Midi_TxNotePlay+0
;electronique_interface_midi_007b_16f628.mpas,327 :: 		Delay_ms(100);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L__Main_Welcome62:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome62
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome62
	DECFSZ     R11+0, 1
	GOTO       L__Main_Welcome62
	NOP
	NOP
;electronique_interface_midi_007b_16f628.mpas,328 :: 		Midi_TxNotePlay(cMIDI_Note_Off_Ch_1, cMIDI_Pitch_base, cMIDI_Vel_Off);
	MOVLW      128
	MOVWF      FARG_Midi_TxNotePlay_Data1+0
	MOVLW      60
	MOVWF      FARG_Midi_TxNotePlay_Data2+0
	CLRF       FARG_Midi_TxNotePlay_Data3+0
	CALL       _Midi_TxNotePlay+0
;electronique_interface_midi_007b_16f628.mpas,329 :: 		Delay_ms(30);
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L__Main_Welcome63:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome63
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome63
;electronique_interface_midi_007b_16f628.mpas,330 :: 		end;
L_end_Main_Welcome:
	RETURN
; end of _Main_Welcome

_Midi_GetChannelSetting:

;electronique_interface_midi_007b_16f628.mpas,333 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,334 :: 		iMidiChannelSet := 0;
	CLRF       _iMidiChannelSet+0
;electronique_interface_midi_007b_16f628.mpas,335 :: 		if In_MidiCh_bit0 then iMidiChannelSet := iMidiChannelSet + 1;
	BTFSS      RB3_bit+0, 3
	GOTO       L__Midi_GetChannelSetting66
	INCF       _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting66:
;electronique_interface_midi_007b_16f628.mpas,336 :: 		if In_MidiCh_bit1 then iMidiChannelSet := iMidiChannelSet + 2;
	BTFSS      RB4_bit+0, 4
	GOTO       L__Midi_GetChannelSetting69
	MOVLW      2
	ADDWF      _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting69:
;electronique_interface_midi_007b_16f628.mpas,337 :: 		if In_MidiCh_bit2 then iMidiChannelSet := iMidiChannelSet + 4;
	BTFSS      RB5_bit+0, 5
	GOTO       L__Midi_GetChannelSetting72
	MOVLW      4
	ADDWF      _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting72:
;electronique_interface_midi_007b_16f628.mpas,338 :: 		if In_MidiCh_bit3 then iMidiChannelSet := iMidiChannelSet + 8;
	BTFSS      RB6_bit+0, 6
	GOTO       L__Midi_GetChannelSetting75
	MOVLW      8
	ADDWF      _iMidiChannelSet+0, 1
L__Midi_GetChannelSetting75:
;electronique_interface_midi_007b_16f628.mpas,339 :: 		end;
L_end_Midi_GetChannelSetting:
	RETURN
; end of _Midi_GetChannelSetting

_main:

;electronique_interface_midi_007b_16f628.mpas,342 :: 		begin
;electronique_interface_midi_007b_16f628.mpas,343 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_interface_midi_007b_16f628.mpas,344 :: 		bRxEcho := In_RxEcho;
	MOVLW      0
	BTFSC      RA3_bit+0, 3
	MOVLW      1
	MOVWF      _bRxEcho+0
;electronique_interface_midi_007b_16f628.mpas,345 :: 		bModePulse := In_Mode;      // RB7=1 > selected out play as pulse
	MOVLW      0
	BTFSC      RB7_bit+0, 7
	MOVLW      1
	MOVWF      _bModePulse+0
;electronique_interface_midi_007b_16f628.mpas,348 :: 		Disp_Init;
	CALL       _Disp_Init+0
;electronique_interface_midi_007b_16f628.mpas,349 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007b_16f628.mpas,352 :: 		Main_Welcome;
	CALL       _Main_Welcome+0
;electronique_interface_midi_007b_16f628.mpas,355 :: 		Midi_GetChannelSetting;
	CALL       _Midi_GetChannelSetting+0
;electronique_interface_midi_007b_16f628.mpas,358 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_007b_16f628.mpas,359 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_007b_16f628.mpas,361 :: 		while true do
L__main79:
;electronique_interface_midi_007b_16f628.mpas,365 :: 		if Midi_DataReceived then
	CALL       _Midi_DataReceived+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main84
;electronique_interface_midi_007b_16f628.mpas,369 :: 		Midi_RxReadByte;
	CALL       _Midi_RxReadByte+0
;electronique_interface_midi_007b_16f628.mpas,372 :: 		if Midi_MsgReceived then
	CALL       _Midi_MsgReceived+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main87
;electronique_interface_midi_007b_16f628.mpas,377 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) and
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_007b_16f628.mpas,378 :: 		(ArrRxData[3] > $00));
	MOVF       _ArrRxData+2, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R3+0
	MOVF       R3+0, 0
	MOVWF      _bNoteOn+0
;electronique_interface_midi_007b_16f628.mpas,381 :: 		(((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) and
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_007b_16f628.mpas,382 :: 		(ArrRxData[3] = $00)) or
	MOVF       _ArrRxData+2, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R2+0
;electronique_interface_midi_007b_16f628.mpas,383 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_Off_Ch_1));
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _bNoteOff+0
;electronique_interface_midi_007b_16f628.mpas,386 :: 		iMidiChannelRx := ArrRxData[1] and $0F;
	MOVLW      15
	ANDWF      _ArrRxData+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      _iMidiChannelRx+0
;electronique_interface_midi_007b_16f628.mpas,389 :: 		if ((bNoteOn or bNoteOff) and (iMidiChannelRx = iMidiChannelSet)) then
	MOVF       R0+0, 0
	IORWF      R3+0, 0
	MOVWF      R1+0
	MOVF       R2+0, 0
	XORWF      _iMidiChannelSet+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main90
;electronique_interface_midi_007b_16f628.mpas,394 :: 		if ((ArrRxData[2] >= 0) and (ArrRxData[2] <= 7)) then
	MOVLW      0
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      7
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main93
;electronique_interface_midi_007b_16f628.mpas,396 :: 		iOutGroup := 0;
	CLRF       _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,397 :: 		iOutBit := ArrRxData[2];
	MOVF       _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,398 :: 		end
	GOTO       L__main94
;electronique_interface_midi_007b_16f628.mpas,399 :: 		else if ((ArrRxData[2] >= 8) and (ArrRxData[2] <= 15)) then
L__main93:
	MOVLW      8
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      15
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main96
;electronique_interface_midi_007b_16f628.mpas,401 :: 		iOutGroup := 1;
	MOVLW      1
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,402 :: 		iOutBit := ArrRxData[2] - 8;
	MOVLW      8
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,403 :: 		end
	GOTO       L__main97
;electronique_interface_midi_007b_16f628.mpas,404 :: 		else if ((ArrRxData[2] >= 16) and (ArrRxData[2] <= 23)) then
L__main96:
	MOVLW      16
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      23
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main99
;electronique_interface_midi_007b_16f628.mpas,406 :: 		iOutGroup := 2;
	MOVLW      2
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,407 :: 		iOutBit := ArrRxData[2] - 16;
	MOVLW      16
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,408 :: 		end
	GOTO       L__main100
;electronique_interface_midi_007b_16f628.mpas,409 :: 		else if ((ArrRxData[2] >= 24) and (ArrRxData[2] <= 31)) then
L__main99:
	MOVLW      24
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      31
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main102
;electronique_interface_midi_007b_16f628.mpas,411 :: 		iOutGroup := 3;
	MOVLW      3
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,412 :: 		iOutBit := ArrRxData[2] - 24;
	MOVLW      24
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,413 :: 		end
	GOTO       L__main103
;electronique_interface_midi_007b_16f628.mpas,414 :: 		else if ((ArrRxData[2] >= 32) and (ArrRxData[2] <= 39)) then
L__main102:
	MOVLW      32
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      39
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main105
;electronique_interface_midi_007b_16f628.mpas,416 :: 		iOutGroup := 4;
	MOVLW      4
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,417 :: 		iOutBit := ArrRxData[2] - 32;
	MOVLW      32
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,418 :: 		end
	GOTO       L__main106
;electronique_interface_midi_007b_16f628.mpas,419 :: 		else if ((ArrRxData[2] >= 40) and (ArrRxData[2] <= 47)) then
L__main105:
	MOVLW      40
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      47
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main108
;electronique_interface_midi_007b_16f628.mpas,421 :: 		iOutGroup := 5;
	MOVLW      5
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,422 :: 		iOutBit := ArrRxData[2] - 40;
	MOVLW      40
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,423 :: 		end
	GOTO       L__main109
;electronique_interface_midi_007b_16f628.mpas,424 :: 		else if ((ArrRxData[2] >= 48) and (ArrRxData[2] <= 55)) then
L__main108:
	MOVLW      48
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      55
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main111
;electronique_interface_midi_007b_16f628.mpas,426 :: 		iOutGroup := 6;
	MOVLW      6
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,427 :: 		iOutBit := ArrRxData[2] - 48;
	MOVLW      48
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,428 :: 		end
	GOTO       L__main112
;electronique_interface_midi_007b_16f628.mpas,429 :: 		else if ((ArrRxData[2] >= 56) and (ArrRxData[2] <= 63)) then
L__main111:
	MOVLW      56
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      63
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main114
;electronique_interface_midi_007b_16f628.mpas,431 :: 		iOutGroup := 7;
	MOVLW      7
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,432 :: 		iOutBit := ArrRxData[2] - 56;
	MOVLW      56
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,433 :: 		end
	GOTO       L__main115
;electronique_interface_midi_007b_16f628.mpas,434 :: 		else if ((ArrRxData[2] >= 64) and (ArrRxData[2] <= 71)) then
L__main114:
	MOVLW      64
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      71
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main117
;electronique_interface_midi_007b_16f628.mpas,436 :: 		iOutGroup := 8;
	MOVLW      8
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,437 :: 		iOutBit := ArrRxData[2] - 64;
	MOVLW      64
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,438 :: 		end
	GOTO       L__main118
;electronique_interface_midi_007b_16f628.mpas,439 :: 		else if ((ArrRxData[2] >= 72) and (ArrRxData[2] <= 79)) then
L__main117:
	MOVLW      72
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      79
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main120
;electronique_interface_midi_007b_16f628.mpas,441 :: 		iOutGroup := 9;
	MOVLW      9
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,442 :: 		iOutBit := ArrRxData[2] - 72;
	MOVLW      72
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,443 :: 		end
	GOTO       L__main121
;electronique_interface_midi_007b_16f628.mpas,444 :: 		else if ((ArrRxData[2] >= 80) and (ArrRxData[2] <= 87)) then
L__main120:
	MOVLW      80
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      87
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main123
;electronique_interface_midi_007b_16f628.mpas,446 :: 		iOutGroup := 10;
	MOVLW      10
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,447 :: 		iOutBit := ArrRxData[2] - 80;
	MOVLW      80
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,448 :: 		end
	GOTO       L__main124
;electronique_interface_midi_007b_16f628.mpas,449 :: 		else if ((ArrRxData[2] >= 88) and (ArrRxData[2] <= 95)) then
L__main123:
	MOVLW      88
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      95
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main126
;electronique_interface_midi_007b_16f628.mpas,451 :: 		iOutGroup := 11;
	MOVLW      11
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,452 :: 		iOutBit := ArrRxData[2] - 88;
	MOVLW      88
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,453 :: 		end
	GOTO       L__main127
;electronique_interface_midi_007b_16f628.mpas,454 :: 		else if ((ArrRxData[2] >= 96) and (ArrRxData[2] <= 103)) then
L__main126:
	MOVLW      96
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      103
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main129
;electronique_interface_midi_007b_16f628.mpas,456 :: 		iOutGroup := 12;
	MOVLW      12
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,457 :: 		iOutBit := ArrRxData[2] - 96;
	MOVLW      96
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,458 :: 		end
	GOTO       L__main130
;electronique_interface_midi_007b_16f628.mpas,459 :: 		else if ((ArrRxData[2] >= 104) and (ArrRxData[2] <= 111)) then
L__main129:
	MOVLW      104
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      111
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main132
;electronique_interface_midi_007b_16f628.mpas,461 :: 		iOutGroup := 13;
	MOVLW      13
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,462 :: 		iOutBit := ArrRxData[2] - 104;
	MOVLW      104
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,463 :: 		end
	GOTO       L__main133
;electronique_interface_midi_007b_16f628.mpas,464 :: 		else if ((ArrRxData[2] >= 112) and (ArrRxData[2] <= 119)) then
L__main132:
	MOVLW      112
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      119
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main135
;electronique_interface_midi_007b_16f628.mpas,466 :: 		iOutGroup := 14;
	MOVLW      14
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,467 :: 		iOutBit := ArrRxData[2] - 112;
	MOVLW      112
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,468 :: 		end
	GOTO       L__main136
;electronique_interface_midi_007b_16f628.mpas,469 :: 		else if ((ArrRxData[2] >= 120) and (ArrRxData[2] <= 127)) then
L__main135:
	MOVLW      120
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      127
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main138
;electronique_interface_midi_007b_16f628.mpas,471 :: 		iOutGroup := 15;
	MOVLW      15
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007b_16f628.mpas,472 :: 		iOutBit := ArrRxData[2] - 120;
	MOVLW      120
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007b_16f628.mpas,473 :: 		end;
L__main138:
L__main136:
L__main133:
L__main130:
L__main127:
L__main124:
L__main121:
L__main118:
L__main115:
L__main112:
L__main109:
L__main106:
L__main103:
L__main100:
L__main97:
L__main94:
;electronique_interface_midi_007b_16f628.mpas,476 :: 		if bModePulse then
	MOVF       _bModePulse+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main141
;electronique_interface_midi_007b_16f628.mpas,480 :: 		if bNoteOn then
	MOVF       _bNoteOn+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main144
;electronique_interface_midi_007b_16f628.mpas,483 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_007b_16f628.mpas,485 :: 		ArrOuts[iOutGroup].iOutBit := 1;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main178:
	BTFSC      STATUS+0, 2
	GOTO       L__main179
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main178
L__main179:
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007b_16f628.mpas,487 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007b_16f628.mpas,489 :: 		Delay_ms(1); // or Delay_ms(10) for example
	MOVLW      7
	MOVWF      R12+0
	MOVLW      125
	MOVWF      R13+0
L__main148:
	DECFSZ     R13+0, 1
	GOTO       L__main148
	DECFSZ     R12+0, 1
	GOTO       L__main148
;electronique_interface_midi_007b_16f628.mpas,491 :: 		ArrOuts[iOutGroup].iOutBit := 0;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main180:
	BTFSC      STATUS+0, 2
	GOTO       L__main181
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main180
L__main181:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007b_16f628.mpas,493 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007b_16f628.mpas,494 :: 		end;
L__main144:
;electronique_interface_midi_007b_16f628.mpas,496 :: 		end
	GOTO       L__main142
;electronique_interface_midi_007b_16f628.mpas,497 :: 		else
L__main141:
;electronique_interface_midi_007b_16f628.mpas,502 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_007b_16f628.mpas,504 :: 		if bNoteOn then
	MOVF       _bNoteOn+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main152
;electronique_interface_midi_007b_16f628.mpas,505 :: 		ArrOuts[iOutGroup].iOutBit := 1
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main182:
	BTFSC      STATUS+0, 2
	GOTO       L__main183
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main182
L__main183:
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	GOTO       L__main153
;electronique_interface_midi_007b_16f628.mpas,506 :: 		else if bNoteOff then
L__main152:
	MOVF       _bNoteOff+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main157
;electronique_interface_midi_007b_16f628.mpas,507 :: 		ArrOuts[iOutGroup].iOutBit := 0;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main184:
	BTFSC      STATUS+0, 2
	GOTO       L__main185
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main184
L__main185:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
L__main157:
L__main153:
;electronique_interface_midi_007b_16f628.mpas,509 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007b_16f628.mpas,510 :: 		end;
L__main142:
;electronique_interface_midi_007b_16f628.mpas,512 :: 		end;
L__main90:
;electronique_interface_midi_007b_16f628.mpas,513 :: 		end;
L__main87:
;electronique_interface_midi_007b_16f628.mpas,514 :: 		end;
L__main84:
;electronique_interface_midi_007b_16f628.mpas,517 :: 		end;
	GOTO       L__main79
;electronique_interface_midi_007b_16f628.mpas,519 :: 		end.
L_end_main:
	GOTO       $+0
; end of _main
